// --- Generated by AidaCxxStub ---
#ifndef __CLNT__BSE_IDL
#define __CLNT__BSE_IDL


// --- ClientHH Boilerplate ---
#include <rapicorn-core.hh>

#ifndef __ENUMHH__BSE_IDL__
#define __ENUMHH__BSE_IDL__

namespace Bse {

/// @cond GeneratedEnums
enum ErrorType {
  ERROR_NONE = 0, // _("OK")
  ERROR_INTERNAL = 1, // _("Internal error (please report)")
  ERROR_UNKNOWN = 2, // _("Unknown error")
  ERROR_IO = 3, // _("Input/output error")
  ERROR_PERMS = 4, // _("Insufficient permissions")
  ERROR_FILE_BUSY = 5, // _("Device or resource busy")
  ERROR_FILE_EXISTS = 6, // _("File exists already")
  ERROR_FILE_EOF = 7, // _("End of file")
  ERROR_FILE_EMPTY = 8, // _("File empty")
  ERROR_FILE_NOT_FOUND = 9, // _("No such file, device or directory")
  ERROR_FILE_IS_DIR = 10, // _("Is a directory")
  ERROR_FILE_OPEN_FAILED = 11, // _("Open failed")
  ERROR_FILE_SEEK_FAILED = 12, // _("Seek failed")
  ERROR_FILE_READ_FAILED = 13, // _("Read failed")
  ERROR_FILE_WRITE_FAILED = 14, // _("Write failed")
  ERROR_MANY_FILES = 15, // _("Too many open files")
  ERROR_NO_FILES = 16, // _("Too many open files in system")
  ERROR_NO_SPACE = 17, // _("No space left on device")
  ERROR_NO_MEMORY = 18, // _("Out of memory")
  ERROR_NO_HEADER = 19, // _("Failed to detect header")
  ERROR_NO_SEEK_INFO = 20, // _("Failed to retrieve seek information")
  ERROR_NO_DATA = 21, // _("No data available")
  ERROR_DATA_CORRUPT = 22, // _("Data corrupt")
  ERROR_WRONG_N_CHANNELS = 23, // _("Wrong number of channels")
  ERROR_FORMAT_INVALID = 24, // _("Invalid format")
  ERROR_FORMAT_UNKNOWN = 25, // _("Unknown format")
  ERROR_DATA_UNMATCHED = 26, // _("Requested data values unmatched")
  ERROR_TEMP = 27, // _("Temporary error")
  ERROR_WAVE_NOT_FOUND = 28, // _("No such wave")
  ERROR_CODEC_FAILURE = 29, // _("Codec failure")
  ERROR_UNIMPLEMENTED = 30, // _("Functionality not implemented")
  ERROR_INVALID_PROPERTY = 31, // _("Invalid object property")
  ERROR_INVALID_MIDI_CONTROL = 32, // _("Invalid MIDI control type")
  ERROR_PARSE_ERROR = 33, // _("Parsing error")
  ERROR_SPAWN = 34, // _("Failed to spawn child process")
  ERROR_DEVICE_NOT_AVAILABLE = 35, // _("No device (driver) available")
  ERROR_DEVICE_ASYNC = 36, // _("Device not async capable")
  ERROR_DEVICE_BUSY = 37, // _("Device busy")
  ERROR_DEVICE_FORMAT = 38, // _("Failed to configure device format")
  ERROR_DEVICE_BUFFER = 39, // _("Failed to configure device buffer")
  ERROR_DEVICE_LATENCY = 40, // _("Failed to configure device latency")
  ERROR_DEVICE_CHANNELS = 41, // _("Failed to configure number of device channels")
  ERROR_DEVICE_FREQUENCY = 42, // _("Failed to configure device frequency")
  ERROR_DEVICES_MISMATCH = 43, // _("Device configurations mismatch")
  ERROR_SOURCE_NO_SUCH_MODULE = 44, // _("No such synthesis module")
  ERROR_SOURCE_NO_SUCH_ICHANNEL = 45, // _("No such input channel")
  ERROR_SOURCE_NO_SUCH_OCHANNEL = 46, // _("No such output channel")
  ERROR_SOURCE_NO_SUCH_CONNECTION = 47, // _("Input/Output channels not connected")
  ERROR_SOURCE_PRIVATE_ICHANNEL = 48, // _("Input channel is private")
  ERROR_SOURCE_ICHANNEL_IN_USE = 49, // _("Input channel already in use")
  ERROR_SOURCE_CHANNELS_CONNECTED = 50, // _("Input/output channels already connected")
  ERROR_SOURCE_CONNECTION_INVALID = 51, // _("Invalid synthesis module connection")
  ERROR_SOURCE_PARENT_MISMATCH = 52, // _("Parent mismatch")
  ERROR_SOURCE_BAD_LOOPBACK = 53, // _("Bad loopback")
  ERROR_SOURCE_BUSY = 54, // _("Synthesis module currently busy")
  ERROR_SOURCE_TYPE_INVALID = 55, // _("Invalid synthsis module type")
  ERROR_PROC_NOT_FOUND = 56, // _("No such procedure")
  ERROR_PROC_BUSY = 57, // _("Procedure currently busy")
  ERROR_PROC_PARAM_INVAL = 58, // _("Procedure parameter invalid")
  ERROR_PROC_EXECUTION = 59, // _("Procedure execution failed")
  ERROR_PROC_ABORT = 60, // _("Procedure execution aborted")
  ERROR_NO_ENTRY = 61, // _("No such entry")
  ERROR_NO_EVENT = 62, // _("No such event")
  ERROR_NO_TARGET = 63, // _("No target")
  ERROR_NOT_OWNER = 64, // _("Ownership mismatch")
  ERROR_INVALID_OFFSET = 65, // _("Invalid offset")
  ERROR_INVALID_DURATION = 66, // _("Invalid duration")
  ERROR_INVALID_OVERLAP = 67, // _("Invalid overlap")
};
inline void operator<<= (Rapicorn::Aida::ProtoMsg &__p_,  ErrorType  e) { __p_ <<= Rapicorn::Aida::EnumValue (e); }
inline void operator>>= (Rapicorn::Aida::ProtoReader &__f_, ErrorType &e) { e = ErrorType (__f_.pop_evalue()); }
/// @endcond

/// @cond GeneratedEnums
enum MidiSignalType {
  MIDI_SIGNAL_PROGRAM = 1,
  MIDI_SIGNAL_PRESSURE = 2,
  MIDI_SIGNAL_PITCH_BEND = 3,
  MIDI_SIGNAL_VELOCITY = 4,
  MIDI_SIGNAL_FINE_TUNE = 5,
  MIDI_SIGNAL_CONTINUOUS_0 = 64,
  MIDI_SIGNAL_CONTINUOUS_1 = 65,
  MIDI_SIGNAL_CONTINUOUS_2 = 66,
  MIDI_SIGNAL_CONTINUOUS_3 = 67,
  MIDI_SIGNAL_CONTINUOUS_4 = 68,
  MIDI_SIGNAL_CONTINUOUS_5 = 69,
  MIDI_SIGNAL_CONTINUOUS_6 = 70,
  MIDI_SIGNAL_CONTINUOUS_7 = 71,
  MIDI_SIGNAL_CONTINUOUS_8 = 72,
  MIDI_SIGNAL_CONTINUOUS_9 = 73,
  MIDI_SIGNAL_CONTINUOUS_10 = 74,
  MIDI_SIGNAL_CONTINUOUS_11 = 75,
  MIDI_SIGNAL_CONTINUOUS_12 = 76,
  MIDI_SIGNAL_CONTINUOUS_13 = 77,
  MIDI_SIGNAL_CONTINUOUS_14 = 78,
  MIDI_SIGNAL_CONTINUOUS_15 = 79,
  MIDI_SIGNAL_CONTINUOUS_16 = 80,
  MIDI_SIGNAL_CONTINUOUS_17 = 81,
  MIDI_SIGNAL_CONTINUOUS_18 = 82,
  MIDI_SIGNAL_CONTINUOUS_19 = 83,
  MIDI_SIGNAL_CONTINUOUS_20 = 84,
  MIDI_SIGNAL_CONTINUOUS_21 = 85,
  MIDI_SIGNAL_CONTINUOUS_22 = 86,
  MIDI_SIGNAL_CONTINUOUS_23 = 87,
  MIDI_SIGNAL_CONTINUOUS_24 = 88,
  MIDI_SIGNAL_CONTINUOUS_25 = 89,
  MIDI_SIGNAL_CONTINUOUS_26 = 90,
  MIDI_SIGNAL_CONTINUOUS_27 = 91,
  MIDI_SIGNAL_CONTINUOUS_28 = 92,
  MIDI_SIGNAL_CONTINUOUS_29 = 93,
  MIDI_SIGNAL_CONTINUOUS_30 = 94,
  MIDI_SIGNAL_CONTINUOUS_31 = 95,
  MIDI_SIGNAL_CONSTANT_HIGH = 96,
  MIDI_SIGNAL_CONSTANT_CENTER = 97,
  MIDI_SIGNAL_CONSTANT_LOW = 98,
  MIDI_SIGNAL_CONSTANT_NEGATIVE_CENTER = 99,
  MIDI_SIGNAL_CONSTANT_NEGATIVE_HIGH = 100,
  MIDI_SIGNAL_PARAMETER = 101,
  MIDI_SIGNAL_NON_PARAMETER = 102,
  MIDI_SIGNAL_CONTROL_0 = 128,
  MIDI_SIGNAL_CONTROL_1 = 129,
  MIDI_SIGNAL_CONTROL_2 = 130,
  MIDI_SIGNAL_CONTROL_3 = 131,
  MIDI_SIGNAL_CONTROL_4 = 132,
  MIDI_SIGNAL_CONTROL_5 = 133,
  MIDI_SIGNAL_CONTROL_6 = 134,
  MIDI_SIGNAL_CONTROL_7 = 135,
  MIDI_SIGNAL_CONTROL_8 = 136,
  MIDI_SIGNAL_CONTROL_9 = 137,
  MIDI_SIGNAL_CONTROL_10 = 138,
  MIDI_SIGNAL_CONTROL_11 = 139,
  MIDI_SIGNAL_CONTROL_12 = 140,
  MIDI_SIGNAL_CONTROL_13 = 141,
  MIDI_SIGNAL_CONTROL_14 = 142,
  MIDI_SIGNAL_CONTROL_15 = 143,
  MIDI_SIGNAL_CONTROL_16 = 144,
  MIDI_SIGNAL_CONTROL_17 = 145,
  MIDI_SIGNAL_CONTROL_18 = 146,
  MIDI_SIGNAL_CONTROL_19 = 147,
  MIDI_SIGNAL_CONTROL_20 = 148,
  MIDI_SIGNAL_CONTROL_21 = 149,
  MIDI_SIGNAL_CONTROL_22 = 150,
  MIDI_SIGNAL_CONTROL_23 = 151,
  MIDI_SIGNAL_CONTROL_24 = 152,
  MIDI_SIGNAL_CONTROL_25 = 153,
  MIDI_SIGNAL_CONTROL_26 = 154,
  MIDI_SIGNAL_CONTROL_27 = 155,
  MIDI_SIGNAL_CONTROL_28 = 156,
  MIDI_SIGNAL_CONTROL_29 = 157,
  MIDI_SIGNAL_CONTROL_30 = 158,
  MIDI_SIGNAL_CONTROL_31 = 159,
  MIDI_SIGNAL_CONTROL_32 = 160,
  MIDI_SIGNAL_CONTROL_33 = 161,
  MIDI_SIGNAL_CONTROL_34 = 162,
  MIDI_SIGNAL_CONTROL_35 = 163,
  MIDI_SIGNAL_CONTROL_36 = 164,
  MIDI_SIGNAL_CONTROL_37 = 165,
  MIDI_SIGNAL_CONTROL_38 = 166,
  MIDI_SIGNAL_CONTROL_39 = 167,
  MIDI_SIGNAL_CONTROL_40 = 168,
  MIDI_SIGNAL_CONTROL_41 = 169,
  MIDI_SIGNAL_CONTROL_42 = 170,
  MIDI_SIGNAL_CONTROL_43 = 171,
  MIDI_SIGNAL_CONTROL_44 = 172,
  MIDI_SIGNAL_CONTROL_45 = 173,
  MIDI_SIGNAL_CONTROL_46 = 174,
  MIDI_SIGNAL_CONTROL_47 = 175,
  MIDI_SIGNAL_CONTROL_48 = 176,
  MIDI_SIGNAL_CONTROL_49 = 177,
  MIDI_SIGNAL_CONTROL_50 = 178,
  MIDI_SIGNAL_CONTROL_51 = 179,
  MIDI_SIGNAL_CONTROL_52 = 180,
  MIDI_SIGNAL_CONTROL_53 = 181,
  MIDI_SIGNAL_CONTROL_54 = 182,
  MIDI_SIGNAL_CONTROL_55 = 183,
  MIDI_SIGNAL_CONTROL_56 = 184,
  MIDI_SIGNAL_CONTROL_57 = 185,
  MIDI_SIGNAL_CONTROL_58 = 186,
  MIDI_SIGNAL_CONTROL_59 = 187,
  MIDI_SIGNAL_CONTROL_60 = 188,
  MIDI_SIGNAL_CONTROL_61 = 189,
  MIDI_SIGNAL_CONTROL_62 = 190,
  MIDI_SIGNAL_CONTROL_63 = 191,
  MIDI_SIGNAL_CONTROL_64 = 192,
  MIDI_SIGNAL_CONTROL_65 = 193,
  MIDI_SIGNAL_CONTROL_66 = 194,
  MIDI_SIGNAL_CONTROL_67 = 195,
  MIDI_SIGNAL_CONTROL_68 = 196,
  MIDI_SIGNAL_CONTROL_69 = 197,
  MIDI_SIGNAL_CONTROL_70 = 198,
  MIDI_SIGNAL_CONTROL_71 = 199,
  MIDI_SIGNAL_CONTROL_72 = 200,
  MIDI_SIGNAL_CONTROL_73 = 201,
  MIDI_SIGNAL_CONTROL_74 = 202,
  MIDI_SIGNAL_CONTROL_75 = 203,
  MIDI_SIGNAL_CONTROL_76 = 204,
  MIDI_SIGNAL_CONTROL_77 = 205,
  MIDI_SIGNAL_CONTROL_78 = 206,
  MIDI_SIGNAL_CONTROL_79 = 207,
  MIDI_SIGNAL_CONTROL_80 = 208,
  MIDI_SIGNAL_CONTROL_81 = 209,
  MIDI_SIGNAL_CONTROL_82 = 210,
  MIDI_SIGNAL_CONTROL_83 = 211,
  MIDI_SIGNAL_CONTROL_84 = 212,
  MIDI_SIGNAL_CONTROL_85 = 213,
  MIDI_SIGNAL_CONTROL_86 = 214,
  MIDI_SIGNAL_CONTROL_87 = 215,
  MIDI_SIGNAL_CONTROL_88 = 216,
  MIDI_SIGNAL_CONTROL_89 = 217,
  MIDI_SIGNAL_CONTROL_90 = 218,
  MIDI_SIGNAL_CONTROL_91 = 219,
  MIDI_SIGNAL_CONTROL_92 = 220,
  MIDI_SIGNAL_CONTROL_93 = 221,
  MIDI_SIGNAL_CONTROL_94 = 222,
  MIDI_SIGNAL_CONTROL_95 = 223,
  MIDI_SIGNAL_CONTROL_96 = 224,
  MIDI_SIGNAL_CONTROL_97 = 225,
  MIDI_SIGNAL_CONTROL_98 = 226,
  MIDI_SIGNAL_CONTROL_99 = 227,
  MIDI_SIGNAL_CONTROL_100 = 228,
  MIDI_SIGNAL_CONTROL_101 = 229,
  MIDI_SIGNAL_CONTROL_102 = 230,
  MIDI_SIGNAL_CONTROL_103 = 231,
  MIDI_SIGNAL_CONTROL_104 = 232,
  MIDI_SIGNAL_CONTROL_105 = 233,
  MIDI_SIGNAL_CONTROL_106 = 234,
  MIDI_SIGNAL_CONTROL_107 = 235,
  MIDI_SIGNAL_CONTROL_108 = 236,
  MIDI_SIGNAL_CONTROL_109 = 237,
  MIDI_SIGNAL_CONTROL_110 = 238,
  MIDI_SIGNAL_CONTROL_111 = 239,
  MIDI_SIGNAL_CONTROL_112 = 240,
  MIDI_SIGNAL_CONTROL_113 = 241,
  MIDI_SIGNAL_CONTROL_114 = 242,
  MIDI_SIGNAL_CONTROL_115 = 243,
  MIDI_SIGNAL_CONTROL_116 = 244,
  MIDI_SIGNAL_CONTROL_117 = 245,
  MIDI_SIGNAL_CONTROL_118 = 246,
  MIDI_SIGNAL_CONTROL_119 = 247,
  MIDI_SIGNAL_CONTROL_120 = 248,
  MIDI_SIGNAL_CONTROL_121 = 249,
  MIDI_SIGNAL_CONTROL_122 = 250,
  MIDI_SIGNAL_CONTROL_123 = 251,
  MIDI_SIGNAL_CONTROL_124 = 252,
  MIDI_SIGNAL_CONTROL_125 = 253,
  MIDI_SIGNAL_CONTROL_126 = 254,
  MIDI_SIGNAL_CONTROL_127 = 255,
};
inline void operator<<= (Rapicorn::Aida::ProtoMsg &__p_,  MidiSignalType  e) { __p_ <<= Rapicorn::Aida::EnumValue (e); }
inline void operator>>= (Rapicorn::Aida::ProtoReader &__f_, MidiSignalType &e) { e = MidiSignalType (__f_.pop_evalue()); }
/// @endcond

/// @cond GeneratedEnums
enum UserMessageType {
  ERROR = 1,
  WARNING = 2,
  INFO = 3,
  DEBUG = 4,
};
inline void operator<<= (Rapicorn::Aida::ProtoMsg &__p_,  UserMessageType  e) { __p_ <<= Rapicorn::Aida::EnumValue (e); }
inline void operator>>= (Rapicorn::Aida::ProtoReader &__f_, UserMessageType &e) { e = UserMessageType (__f_.pop_evalue()); }
/// @endcond
} // Bse

namespace Rapicorn {

namespace Aida {
template<> EnumInfo enum_info<Bse::ErrorType> ();
template<> EnumInfo enum_info<Bse::MidiSignalType> ();
template<> EnumInfo enum_info<Bse::UserMessageType> ();
} // Aida
} // Rapicorn

#endif // __ENUMHH__BSE_IDL__


// --- Interfaces (class declarations) ---

namespace Bse {

/** @interface TestObject
 * See also the corresponding C++ stub class TestObjectHandle. */
/// See also the corresponding IDL class TestObject.
class TestObjectHandle : public virtual Rapicorn::Aida::RemoteHandle
{
  typedef Rapicorn::Aida::Connector<TestObjectHandle, void (const std::string &msg)> __Aida_Signal__echo_reply;
  size_t __aida_connect__echo_reply (size_t, const std::function<void (const std::string &msg)>&);
  static TestObjectHandle                __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~TestObjectHandle () override;
  template<class RemoteHandle>
  static TestObjectHandle       down_cast (RemoteHandle smh) { return smh == NULL ? TestObjectHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      TestObjectHandle ();
  __Aida_Signal__echo_reply     sig_echo_reply () { return __Aida_Signal__echo_reply (*this, &TestObjectHandle::__aida_connect__echo_reply); }
  int                           echo_test        (const std::string &msg); 	///< See TestObject::echo_test()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {}
};
typedef TestObjectHandle TestObjectH; ///< Convenience alias for the IDL type TestObject.

struct ClnT_UserMessage
{
  /// @cond GeneratedFields
  UserMessageType               type;
  std::string                   title;
  std::string                   text1;
  std::string                   text2;
  std::string                   text3;
  std::string                   label;
  /// @endcond
  inline                        ClnT_UserMessage () { type = UserMessageType (0); }
  std::string                   __aida_type_name__ () const	{ return "Bse::UserMessage"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_UserMessage &other) const;
  bool                          operator!=  (const ClnT_UserMessage &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (type, "type");
    _visitor_ (title, "title");
    _visitor_ (text1, "text1");
    _visitor_ (text2, "text2");
    _visitor_ (text3, "text3");
    _visitor_ (label, "label");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_UserMessage&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_UserMessage&);

struct ClnT_SongTiming
{
  /// @cond GeneratedFields
  int                           tick;
  double                        bpm;
  int                           numerator;
  int                           denominator;
  int                           tpqn;
  int                           tpt;
  double                        stamp_ticks;
  /// @endcond
  inline                        ClnT_SongTiming () { tick = 0; bpm = 0; numerator = 0; denominator = 0; tpqn = 0; tpt = 0; stamp_ticks = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::SongTiming"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_SongTiming &other) const;
  bool                          operator!=  (const ClnT_SongTiming &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (tick, "tick");
    _visitor_ (bpm, "bpm");
    _visitor_ (numerator, "numerator");
    _visitor_ (denominator, "denominator");
    _visitor_ (tpqn, "tpqn");
    _visitor_ (tpt, "tpt");
    _visitor_ (stamp_ticks, "stamp_ticks");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_SongTiming&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_SongTiming&);

class ClnT_PartLink;

class ClnT_PartLinkSeq;

/** @interface Object
 * See also the corresponding C++ stub class ObjectHandle. */
/// See also the corresponding IDL class Object.
class ObjectHandle : public virtual Rapicorn::Aida::RemoteHandle
{
  static ObjectHandle                    __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~ObjectHandle () override;
  template<class RemoteHandle>
  static ObjectHandle           down_cast (RemoteHandle smh) { return smh == NULL ? ObjectHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      ObjectHandle ();
  std::string                   debug_name   (); 	///< See Object::debug_name()
  int64_t                       proxy_id     (); 	///< See Object::proxy_id()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {}
};
typedef ObjectHandle ObjectH; ///< Convenience alias for the IDL type Object.

/** @interface Item
 * See also the corresponding C++ stub class ItemHandle. */
/// See also the corresponding IDL class Item.
class ItemHandle : public virtual ObjectHandle
{
  static ItemHandle                      __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~ItemHandle () override;
  template<class RemoteHandle>
  static ItemHandle             down_cast (RemoteHandle smh) { return smh == NULL ? ItemHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      ItemHandle ();
  ItemHandle                    common_ancestor (ItemHandle &other); 	///< See Item::common_ancestor()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ObjectHandle::__accept_accessor__ (__visitor_);
  }
};
typedef ItemHandle ItemH; ///< Convenience alias for the IDL type Item.

struct ClnT_PartNote
{
  /// @cond GeneratedFields
  int                           id;
  int                           channel;
  int                           tick;
  int                           duration;
  int                           note;
  int                           fine_tune;
  double                        velocity;
  bool                          selected;
  /// @endcond
  inline                        ClnT_PartNote () { id = 0; channel = 0; tick = 0; duration = 0; note = 0; fine_tune = 0; velocity = 0; selected = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartNote"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_PartNote &other) const;
  bool                          operator!=  (const ClnT_PartNote &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (id, "id");
    _visitor_ (channel, "channel");
    _visitor_ (tick, "tick");
    _visitor_ (duration, "duration");
    _visitor_ (note, "note");
    _visitor_ (fine_tune, "fine_tune");
    _visitor_ (velocity, "velocity");
    _visitor_ (selected, "selected");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartNote&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartNote&);

struct ClnT_PartNoteSeq : public std::vector<ClnT_PartNote>
{
  typedef std::vector<ClnT_PartNote> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartNoteSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartNoteSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartNoteSeq&);

struct ClnT_PartControl
{
  /// @cond GeneratedFields
  int                           id;
  int                           tick;
  MidiSignalType                control_type;
  double                        value;
  bool                          selected;
  /// @endcond
  inline                        ClnT_PartControl () { id = 0; tick = 0; control_type = MidiSignalType (0); value = 0; selected = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartControl"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_PartControl &other) const;
  bool                          operator!=  (const ClnT_PartControl &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (id, "id");
    _visitor_ (tick, "tick");
    _visitor_ (control_type, "control_type");
    _visitor_ (value, "value");
    _visitor_ (selected, "selected");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartControl&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartControl&);

struct ClnT_PartControlSeq : public std::vector<ClnT_PartControl>
{
  typedef std::vector<ClnT_PartControl> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartControlSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartControlSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartControlSeq&);

/** @interface Part
 * See also the corresponding C++ stub class PartHandle. */
/// See also the corresponding IDL class Part.
class PartHandle : public virtual ItemHandle
{
  static PartHandle                      __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~PartHandle () override;
  template<class RemoteHandle>
  static PartHandle             down_cast (RemoteHandle smh) { return smh == NULL ? PartHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      PartHandle ();
  ClnT_PartControlSeq           list_selected_controls    (MidiSignalType control_type); 	///< See Part::list_selected_controls()
  ClnT_PartControlSeq           list_controls             (int tick,
                                                           int duration,
                                                           MidiSignalType control_type); 	///< See Part::list_controls()
  ClnT_PartControlSeq           get_channel_controls      (int channel,
                                                           int tick,
                                                           int duration,
                                                           MidiSignalType control_type); 	///< See Part::get_channel_controls()
  ClnT_PartControlSeq           get_controls              (int tick,
                                                           MidiSignalType control_type); 	///< See Part::get_controls()
  ClnT_SongTiming               get_timing                (int tick); 	///< See Part::get_timing()
  int                           get_max_note              (); 	///< See Part::get_max_note()
  int                           get_min_note              (); 	///< See Part::get_min_note()
  ErrorType                     change_control            (int id,
                                                           int tick,
                                                           MidiSignalType control_type,
                                                           double value); 	///< See Part::change_control()
  ErrorType                     change_note               (int id,
                                                           int tick,
                                                           int duration,
                                                           int note,
                                                           int fine_tune,
                                                           double velocity); 	///< See Part::change_note()
  ErrorType                     delete_event              (int id); 	///< See Part::delete_event()
  int                           insert_control            (int tick,
                                                           MidiSignalType control_type,
                                                           double value); 	///< See Part::insert_control()
  int                           insert_note               (int channel,
                                                           int tick,
                                                           int duration,
                                                           int note,
                                                           int fine_tune,
                                                           double velocity); 	///< See Part::insert_note()
  int                           insert_note_auto          (int tick,
                                                           int duration,
                                                           int note,
                                                           int fine_tune,
                                                           double velocity); 	///< See Part::insert_note_auto()
  bool                          is_event_selected         (int id); 	///< See Part::is_event_selected()
  void                          queue_controls            (int tick,
                                                           int duration); 	///< See Part::queue_controls()
  void                          queue_notes               (int tick,
                                                           int duration,
                                                           int min_note,
                                                           int max_note); 	///< See Part::queue_notes()
  void                          select_notes_exclusive    (int tick,
                                                           int duration,
                                                           int min_note,
                                                           int max_note); 	///< See Part::select_notes_exclusive()
  void                          select_controls_exclusive (int tick,
                                                           int duration,
                                                           MidiSignalType control_type); 	///< See Part::select_controls_exclusive()
  void                          select_notes              (int tick,
                                                           int duration,
                                                           int min_note,
                                                           int max_note); 	///< See Part::select_notes()
  void                          select_event              (int id); 	///< See Part::select_event()
  void                          select_controls           (int tick,
                                                           int duration,
                                                           MidiSignalType control_type); 	///< See Part::select_controls()
  void                          deselect_notes            (int tick,
                                                           int duration,
                                                           int min_note,
                                                           int max_note); 	///< See Part::deselect_notes()
  void                          deselect_event            (int id); 	///< See Part::deselect_event()
  void                          deselect_controls         (int tick,
                                                           int duration,
                                                           MidiSignalType control_type); 	///< See Part::deselect_controls()
  ClnT_PartNoteSeq              list_notes_crossing       (int tick,
                                                           int duration); 	///< See Part::list_notes_crossing()
  ClnT_PartNoteSeq              list_notes_within         (int channel,
                                                           int tick,
                                                           int duration); 	///< See Part::list_notes_within()
  ClnT_PartNoteSeq              list_selected_notes       (); 	///< See Part::list_selected_notes()
  ClnT_PartNoteSeq              check_overlap             (int tick,
                                                           int duration,
                                                           int note); 	///< See Part::check_overlap()
  ClnT_PartNoteSeq              get_notes                 (int tick,
                                                           int note); 	///< See Part::get_notes()
  ClnT_PartLinkSeq              list_links                (); 	///< See Part::list_links()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemHandle::__accept_accessor__ (__visitor_);
  }
};
typedef PartHandle PartH; ///< Convenience alias for the IDL type Part.

/** @interface Source
 * See also the corresponding C++ stub class SourceHandle. */
/// See also the corresponding IDL class Source.
class SourceHandle : public virtual ItemHandle
{
  static SourceHandle                    __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~SourceHandle () override;
  template<class RemoteHandle>
  static SourceHandle           down_cast (RemoteHandle smh) { return smh == NULL ? SourceHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      SourceHandle ();
  SourceHandle                  ichannel_get_osource (int input_channel,
                                                      int input_joint); 	///< See Source::ichannel_get_osource()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemHandle::__accept_accessor__ (__visitor_);
  }
};
typedef SourceHandle SourceH; ///< Convenience alias for the IDL type Source.

/** @interface ContextMerger
 * See also the corresponding C++ stub class ContextMergerHandle. */
/// See also the corresponding IDL class ContextMerger.
class ContextMergerHandle : public virtual SourceHandle
{
  static ContextMergerHandle             __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~ContextMergerHandle () override;
  template<class RemoteHandle>
  static ContextMergerHandle    down_cast (RemoteHandle smh) { return smh == NULL ? ContextMergerHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      ContextMergerHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SourceHandle::__accept_accessor__ (__visitor_);
  }
};
typedef ContextMergerHandle ContextMergerH; ///< Convenience alias for the IDL type ContextMerger.

/** @interface Container
 * See also the corresponding C++ stub class ContainerHandle. */
/// See also the corresponding IDL class Container.
class ContainerHandle : public virtual SourceHandle
{
  static ContainerHandle                 __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~ContainerHandle () override;
  template<class RemoteHandle>
  static ContainerHandle        down_cast (RemoteHandle smh) { return smh == NULL ? ContainerHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      ContainerHandle ();
  ItemHandle                    lookup_item     (const std::string &uname); 	///< See Container::lookup_item()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SourceHandle::__accept_accessor__ (__visitor_);
  }
};
typedef ContainerHandle ContainerH; ///< Convenience alias for the IDL type Container.

/** @interface Super
 * See also the corresponding C++ stub class SuperHandle. */
/// See also the corresponding IDL class Super.
class SuperHandle : public virtual ContainerHandle
{
  static SuperHandle                     __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~SuperHandle () override;
  template<class RemoteHandle>
  static SuperHandle            down_cast (RemoteHandle smh) { return smh == NULL ? SuperHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      SuperHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ContainerHandle::__accept_accessor__ (__visitor_);
  }
};
typedef SuperHandle SuperH; ///< Convenience alias for the IDL type Super.

/** @interface SNet
 * See also the corresponding C++ stub class SNetHandle. */
/// See also the corresponding IDL class SNet.
class SNetHandle : public virtual SuperHandle
{
  static SNetHandle                      __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~SNetHandle () override;
  template<class RemoteHandle>
  static SNetHandle             down_cast (RemoteHandle smh) { return smh == NULL ? SNetHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      SNetHandle ();
  bool                          supports_user_synths (); 	///< See SNet::supports_user_synths()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SuperHandle::__accept_accessor__ (__visitor_);
  }
};
typedef SNetHandle SNetH; ///< Convenience alias for the IDL type SNet.

/** @interface CSynth
 * See also the corresponding C++ stub class CSynthHandle. */
/// See also the corresponding IDL class CSynth.
class CSynthHandle : public virtual SNetHandle
{
  static CSynthHandle                    __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~CSynthHandle () override;
  template<class RemoteHandle>
  static CSynthHandle           down_cast (RemoteHandle smh) { return smh == NULL ? CSynthHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      CSynthHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SNetHandle::__accept_accessor__ (__visitor_);
  }
};
typedef CSynthHandle CSynthH; ///< Convenience alias for the IDL type CSynth.

/** @interface SubSynth
 * See also the corresponding C++ stub class SubSynthHandle. */
/// See also the corresponding IDL class SubSynth.
class SubSynthHandle : public virtual SourceHandle
{
  static SubSynthHandle                  __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~SubSynthHandle () override;
  template<class RemoteHandle>
  static SubSynthHandle         down_cast (RemoteHandle smh) { return smh == NULL ? SubSynthHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      SubSynthHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SourceHandle::__accept_accessor__ (__visitor_);
  }
};
typedef SubSynthHandle SubSynthH; ///< Convenience alias for the IDL type SubSynth.

/** @interface Track
 * See also the corresponding C++ stub class TrackHandle. */
/// See also the corresponding IDL class Track.
class TrackHandle : public virtual ContextMergerHandle
{
  static TrackHandle                     __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~TrackHandle () override;
  template<class RemoteHandle>
  static TrackHandle            down_cast (RemoteHandle smh) { return smh == NULL ? TrackHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      TrackHandle ();
  ClnT_SongTiming               get_timing        (int tick); 	///< See Track::get_timing()
  int                           insert_part       (int tick,
                                                   PartHandle &part); 	///< See Track::insert_part()
  void                          remove_tick       (int tick); 	///< See Track::remove_tick()
  PartHandle                    get_part          (int tick); 	///< See Track::get_part()
  int                           get_last_tick     (); 	///< See Track::get_last_tick()
  ErrorType                     ensure_output     (); 	///< See Track::ensure_output()
  SourceHandle                  get_output_source (); 	///< See Track::get_output_source()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ContextMergerHandle::__accept_accessor__ (__visitor_);
  }
};
typedef TrackHandle TrackH; ///< Convenience alias for the IDL type Track.

struct ClnT_PartLink
{
  /// @cond GeneratedFields
  Rapicorn::Aida::RemoteMember<TrackHandle> track;
  int                           tick;
  Rapicorn::Aida::RemoteMember<PartHandle> part;
  int                           duration;
  /// @endcond
  inline                        ClnT_PartLink () { tick = 0; duration = 0; }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartLink"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_visitable (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_visitable (any, *this); }
  bool                          operator==  (const ClnT_PartLink &other) const;
  bool                          operator!=  (const ClnT_PartLink &other) const { return !operator== (other); }
  template<class Visitor> void  __accept__  (Visitor &_visitor_)
  {
    _visitor_ (track, "track");
    _visitor_ (tick, "tick");
    _visitor_ (part, "part");
    _visitor_ (duration, "duration");
  }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartLink&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartLink&);

struct ClnT_PartLinkSeq : public std::vector<ClnT_PartLink>
{
  typedef std::vector<ClnT_PartLink> Sequence;
  reference append_back() ///< Append data at the end, returns write reference to data.
  { resize (size() + 1); return back(); }
  std::string                   __aida_type_name__ () const	{ return "Bse::PartLinkSeq"; }
  std::vector<std::string>      __aida_aux_data__ () const;
  Rapicorn::Aida::Any           __aida_to_any__   () { return Rapicorn::any_from_sequence (*this); }
  void                          __aida_from_any__ (const Rapicorn::Aida::Any &any) { return Rapicorn::any_to_sequence (any, *this); }
};
void operator<<= (Rapicorn::Aida::ProtoMsg&, const ClnT_PartLinkSeq&);
void operator>>= (Rapicorn::Aida::ProtoReader&, ClnT_PartLinkSeq&);

/** @interface Bus
 * See also the corresponding C++ stub class BusHandle. */
/// See also the corresponding IDL class Bus.
class BusHandle : public virtual SubSynthHandle
{
  static BusHandle                       __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~BusHandle () override;
  template<class RemoteHandle>
  static BusHandle              down_cast (RemoteHandle smh) { return smh == NULL ? BusHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      BusHandle ();
  ErrorType                     ensure_output (); 	///< See Bus::ensure_output()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SubSynthHandle::__accept_accessor__ (__visitor_);
  }
};
typedef BusHandle BusH; ///< Convenience alias for the IDL type Bus.

/** @interface Song
 * See also the corresponding C++ stub class SongHandle. */
/// See also the corresponding IDL class Song.
class SongHandle : public virtual SNetHandle
{
  static SongHandle                      __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~SongHandle () override;
  template<class RemoteHandle>
  static SongHandle             down_cast (RemoteHandle smh) { return smh == NULL ? SongHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      SongHandle ();
  double                        bpm () const; 	///< See Song::bpm
  void                          bpm (double); 	///< See Song::bpm
  ClnT_SongTiming               get_timing              (int tick); 	///< See Song::get_timing()
  TrackHandle                   find_any_track_for_part (PartHandle &part); 	///< See Song::find_any_track_for_part()
  BusHandle                     create_bus              (); 	///< See Song::create_bus()
  void                          remove_bus              (BusHandle &bus); 	///< See Song::remove_bus()
  PartHandle                    create_part             (); 	///< See Song::create_part()
  void                          remove_part             (PartHandle &part); 	///< See Song::remove_part()
  TrackHandle                   create_track            (); 	///< See Song::create_track()
  void                          remove_track            (TrackHandle &track); 	///< See Song::remove_track()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    __visitor_ (*this, "bpm", &SongHandle::bpm, &SongHandle::bpm);
    this->SNetHandle::__accept_accessor__ (__visitor_);
  }
};
typedef SongHandle SongH; ///< Convenience alias for the IDL type Song.

/** @interface EditableSample
 * See also the corresponding C++ stub class EditableSampleHandle. */
/// See also the corresponding IDL class EditableSample.
class EditableSampleHandle : public virtual ItemHandle
{
  static EditableSampleHandle            __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~EditableSampleHandle () override;
  template<class RemoteHandle>
  static EditableSampleHandle   down_cast (RemoteHandle smh) { return smh == NULL ? EditableSampleHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      EditableSampleHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemHandle::__accept_accessor__ (__visitor_);
  }
};
typedef EditableSampleHandle EditableSampleH; ///< Convenience alias for the IDL type EditableSample.

/** @interface Wave
 * See also the corresponding C++ stub class WaveHandle. */
/// See also the corresponding IDL class Wave.
class WaveHandle : public virtual SourceHandle
{
  static WaveHandle                      __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~WaveHandle () override;
  template<class RemoteHandle>
  static WaveHandle             down_cast (RemoteHandle smh) { return smh == NULL ? WaveHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      WaveHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SourceHandle::__accept_accessor__ (__visitor_);
  }
};
typedef WaveHandle WaveH; ///< Convenience alias for the IDL type Wave.

/** @interface WaveRepo
 * See also the corresponding C++ stub class WaveRepoHandle. */
/// See also the corresponding IDL class WaveRepo.
class WaveRepoHandle : public virtual SuperHandle
{
  static WaveRepoHandle                  __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~WaveRepoHandle () override;
  template<class RemoteHandle>
  static WaveRepoHandle         down_cast (RemoteHandle smh) { return smh == NULL ? WaveRepoHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      WaveRepoHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SuperHandle::__accept_accessor__ (__visitor_);
  }
};
typedef WaveRepoHandle WaveRepoH; ///< Convenience alias for the IDL type WaveRepo.

/** @interface MidiNotifier
 * See also the corresponding C++ stub class MidiNotifierHandle. */
/// See also the corresponding IDL class MidiNotifier.
class MidiNotifierHandle : public virtual ItemHandle
{
  static MidiNotifierHandle              __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~MidiNotifierHandle () override;
  template<class RemoteHandle>
  static MidiNotifierHandle     down_cast (RemoteHandle smh) { return smh == NULL ? MidiNotifierHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      MidiNotifierHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemHandle::__accept_accessor__ (__visitor_);
  }
};
typedef MidiNotifierHandle MidiNotifierH; ///< Convenience alias for the IDL type MidiNotifier.

/** @interface MidiSynth
 * See also the corresponding C++ stub class MidiSynthHandle. */
/// See also the corresponding IDL class MidiSynth.
class MidiSynthHandle : public virtual SNetHandle
{
  static MidiSynthHandle                 __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~MidiSynthHandle () override;
  template<class RemoteHandle>
  static MidiSynthHandle        down_cast (RemoteHandle smh) { return smh == NULL ? MidiSynthHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      MidiSynthHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->SNetHandle::__accept_accessor__ (__visitor_);
  }
};
typedef MidiSynthHandle MidiSynthH; ///< Convenience alias for the IDL type MidiSynth.

/** @interface Project
 * See also the corresponding C++ stub class ProjectHandle. */
/// See also the corresponding IDL class Project.
class ProjectHandle : public virtual ContainerHandle
{
  static ProjectHandle                   __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~ProjectHandle () override;
  template<class RemoteHandle>
  static ProjectHandle          down_cast (RemoteHandle smh) { return smh == NULL ? ProjectHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      ProjectHandle ();
  void                          change_name         (const std::string &name); 	///< See Project::change_name()
  ErrorType                     play                (); 	///< See Project::play()
  ErrorType                     activate            (); 	///< See Project::activate()
  bool                          can_play            (); 	///< See Project::can_play()
  bool                          is_playing          (); 	///< See Project::is_playing()
  bool                          is_active           (); 	///< See Project::is_active()
  void                          start_playback      (); 	///< See Project::start_playback()
  void                          stop_playback       (); 	///< See Project::stop_playback()
  void                          deactivate          (); 	///< See Project::deactivate()
  void                          stop                (); 	///< See Project::stop()
  void                          auto_deactivate     (int msec_delay); 	///< See Project::auto_deactivate()
  int                           undo_depth          (); 	///< See Project::undo_depth()
  void                          undo                (); 	///< See Project::undo()
  int                           redo_depth          (); 	///< See Project::redo_depth()
  void                          redo                (); 	///< See Project::redo()
  void                          clear_undo          (); 	///< See Project::clear_undo()
  void                          clean_dirty         (); 	///< See Project::clean_dirty()
  bool                          is_dirty            (); 	///< See Project::is_dirty()
  void                          inject_midi_control (int midi_channel,
                                                     int midi_control,
                                                     double control_value); 	///< See Project::inject_midi_control()
  ErrorType                     import_midi_file    (const std::string &file_name); 	///< See Project::import_midi_file()
  ErrorType                     restore_from_file   (const std::string &file_name); 	///< See Project::restore_from_file()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ContainerHandle::__accept_accessor__ (__visitor_);
  }
};
typedef ProjectHandle ProjectH; ///< Convenience alias for the IDL type Project.

/** @interface PcmWriter
 * See also the corresponding C++ stub class PcmWriterHandle. */
/// See also the corresponding IDL class PcmWriter.
class PcmWriterHandle : public virtual ItemHandle
{
  static PcmWriterHandle                 __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~PcmWriterHandle () override;
  template<class RemoteHandle>
  static PcmWriterHandle        down_cast (RemoteHandle smh) { return smh == NULL ? PcmWriterHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      PcmWriterHandle ();
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ItemHandle::__accept_accessor__ (__visitor_);
  }
};
typedef PcmWriterHandle PcmWriterH; ///< Convenience alias for the IDL type PcmWriter.

/** @interface Server
 * See also the corresponding C++ stub class ServerHandle. */
/// See also the corresponding IDL class Server.
class ServerHandle : public virtual ObjectHandle
{
  typedef Rapicorn::Aida::Connector<ServerHandle, void (const ClnT_UserMessage &umsg)> __Aida_Signal__user_message;
  size_t __aida_connect__user_message (size_t, const std::function<void (const ClnT_UserMessage &umsg)>&);
  static ServerHandle                    __aida_cast__ (Rapicorn::Aida::RemoteHandle&, const Rapicorn::Aida::TypeHashList&);
  static const Rapicorn::Aida::TypeHash& __aida_typeid__();
protected:
public:
  virtual /*Des*/                       ~ServerHandle () override;
  template<class RemoteHandle>
  static ServerHandle           down_cast (RemoteHandle smh) { return smh == NULL ? ServerHandle() : __aida_cast__ (smh, smh.__aida_typelist__()); }
  explicit                      ServerHandle ();
  __Aida_Signal__user_message   sig_user_message () { return __Aida_Signal__user_message (*this, &ServerHandle::__aida_connect__user_message); }
  TestObjectHandle              get_test_object           (); 	///< See Server::get_test_object()
  ObjectHandle                  from_proxy                (int64_t proxyid); 	///< See Server::from_proxy()
  std::string                   get_mp3_version           (); 	///< See Server::get_mp3_version()
  std::string                   get_vorbis_version        (); 	///< See Server::get_vorbis_version()
  std::string                   get_ladspa_path           (); 	///< See Server::get_ladspa_path()
  std::string                   get_plugin_path           (); 	///< See Server::get_plugin_path()
  std::string                   get_script_path           (); 	///< See Server::get_script_path()
  std::string                   get_instrument_path       (); 	///< See Server::get_instrument_path()
  std::string                   get_sample_path           (); 	///< See Server::get_sample_path()
  std::string                   get_effect_path           (); 	///< See Server::get_effect_path()
  std::string                   get_demo_path             (); 	///< See Server::get_demo_path()
  std::string                   get_custom_instrument_dir (); 	///< See Server::get_custom_instrument_dir()
  std::string                   get_custom_effect_dir     (); 	///< See Server::get_custom_effect_dir()
  std::string                   get_version               (); 	///< See Server::get_version()
  void                          save_preferences          (); 	///< See Server::save_preferences()
  void                          register_ladspa_plugins   (); 	///< See Server::register_ladspa_plugins()
  void                          register_core_plugins     (); 	///< See Server::register_core_plugins()
  void                          register_scripts          (); 	///< See Server::register_scripts()
  bool                          preferences_locked        (); 	///< See Server::preferences_locked()
  int                           n_scripts                 (); 	///< See Server::n_scripts()
  bool                          can_load                  (const std::string &file_name); 	///< See Server::can_load()
  void                          start_recording           (const std::string &wave_file,
                                                           double n_seconds); 	///< See Server::start_recording()
  ProjectHandle                 create_project            (const std::string &project_name); 	///< See Server::create_project()
  void                          destroy_project           (ProjectHandle &project); 	///< See Server::destroy_project()
  template<class Visitor> void  __accept_accessor__ (Visitor &__visitor_)
  {
    this->ObjectHandle::__accept_accessor__ (__visitor_);
  }
};
typedef ServerHandle ServerH; ///< Convenience alias for the IDL type Server.
} // Bse

// C++ Aliases
#ifndef __BSE_IDL_ALIASES__
#define __BSE_IDL_ALIASES__    1
#endif
#if     __BSE_IDL_ALIASES__ == 1
namespace Bse {
typedef ClnT_UserMessage UserMessage;
typedef ClnT_SongTiming SongTiming;
typedef ClnT_PartNote PartNote;
typedef ClnT_PartNoteSeq PartNoteSeq;
typedef ClnT_PartControl PartControl;
typedef ClnT_PartControlSeq PartControlSeq;
typedef ClnT_PartLink PartLink;
typedef ClnT_PartLinkSeq PartLinkSeq;
} // Bse
#endif // __BSE_IDL_ALIASES__

#endif /* __CLNT__BSE_IDL */
