
/*
 * Generated data (by mkcproc.pl)
 */
#line 1 "bsetrack.proc"
// Licensed GNU LGPL v2.1 or later: http://www.gnu.org/licenses/lgpl.html
#include <bse/bseplugin.hh>
#include <bse/bseprocedure.hh>
#include <bse/bsetrack.hh>
#include <bse/bsepart.hh>
#include <bse/bsesong.hh>
#include <bse/bsebus.hh>
#include <bse/bseundostack.hh>
#include "bsecxxplugin.hh"


#line 14 "bsetrack.proc"


/* --- remove-link --- */
static void
remove_link_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 16 "bsetrack.proc"
 {
#line 18 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", "Track", NULL,
				 BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_int ("id", "Link ID", NULL,
			 0, 0, SFI_MAXINT, 384, SFI_PARAM_STANDARD);
}
#line 23 "bsetrack.proc"
 }
static Bse::ErrorType
#line 23 "bsetrack.proc"
remove_link_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 26 "bsetrack.proc"
{
#line 27 "bsetrack.proc"
  
  BseTrack *self = (BseTrack*) bse_value_get_object (in_values++);
  guint     id   = sfi_value_get_int (in_values++);
  BseTrackEntry *entry;

#line 32 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (self))
    return Bse::ERROR_PROC_PARAM_INVAL;
  entry = bse_track_find_link (self, id);
  if (!entry)
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 39 "bsetrack.proc"
  
  bse_item_push_undo_proc (self, "insert-part", entry->tick, entry->part);
  bse_track_remove_tick (self, entry->tick);

  return Bse::ERROR_NONE;
}

/* --- list-parts --- */
static void
list_parts_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 46 "bsetrack.proc"
 {
#line 48 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", "Track", NULL,
				 BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("part_list", "Part List", NULL,
				BSE_TYPE_TRACK_PART_SEQ, SFI_PARAM_STANDARD);
}
#line 53 "bsetrack.proc"
 }
static Bse::ErrorType
#line 53 "bsetrack.proc"
list_parts_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 56 "bsetrack.proc"
{
#line 57 "bsetrack.proc"
  
  BseTrack *self = (BseTrack*) bse_value_get_object (in_values++);

#line 60 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (self))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 64 "bsetrack.proc"
  
  bse_value_take_boxed (out_values++, bse_track_list_parts (self));

  return Bse::ERROR_NONE;
}

/* --- list-parts-uniq --- */
static void
list_parts_uniq_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 70 "bsetrack.proc"
 {
#line 72 "bsetrack.proc"
  *(in_pspecs++)    = bse_param_spec_object ("track", "Track", NULL,
				 BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("part_list", "Part List", NULL,
				BSE_TYPE_ITEM_SEQ, SFI_PARAM_STANDARD); // FIXME: should use BsePartSeq here
}
#line 77 "bsetrack.proc"
 }
static Bse::ErrorType
#line 77 "bsetrack.proc"
list_parts_uniq_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 80 "bsetrack.proc"
{
#line 81 "bsetrack.proc"
  
  BseTrack *self = (BseTrack*) bse_value_get_object (in_values++);

#line 84 "bsetrack.proc"
  
  if (!BSE_IS_TRACK (self))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 88 "bsetrack.proc"
  
  BseTrackPartSeq *tpseq = bse_track_list_parts (self);
  SfiRing *ring = NULL;
  guint i;
  for (i = 0; i < tpseq->n_tparts; i++)
    ring = sfi_ring_append (ring, tpseq->tparts[i]->part);
  bse_track_part_seq_free (tpseq);
  ring = sfi_ring_sort (ring, sfi_pointer_cmp, NULL);
  ring = sfi_ring_uniq (ring, sfi_pointer_cmp, NULL);
  bse_value_take_boxed (out_values++, bse_item_seq_from_ring (ring));
  sfi_ring_free (ring);

  return Bse::ERROR_NONE;
}

/* --- Export to BSE --- */
static void
__enode_remove_link__fill_strings (BseExportStrings *es)
{
  es->blurb = "Remove a specific part link by ID from a track.";
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 17;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_remove_link = {
  { NULL, BSE_EXPORT_NODE_PROC,
    "BseTrack+remove-link", 
    NULL,
    "/Methods/BseTrack/General/Remove Link",
    NULL,
    __enode_remove_link__fill_strings,
  },
  0, remove_link_setup, remove_link_exec, 
};
static void
__enode_list_parts__fill_strings (BseExportStrings *es)
{
  es->blurb = "List parts scheduled in a track, sorted by tick.";
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 47;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_list_parts = {
  { (BseExportNode*) &__enode_remove_link, BSE_EXPORT_NODE_PROC,
    "BseTrack+list-parts", 
    NULL,
    "/Methods/BseTrack/General/List Parts",
    NULL,
    __enode_list_parts__fill_strings,
  },
  0, list_parts_setup, list_parts_exec, 
};
static void
__enode_list_parts_uniq__fill_strings (BseExportStrings *es)
{
  es->blurb = "List all parts contained in a track.";
  es->file = "/opt/src/beast/bse/bsetrack.proc";
  es->line = 71;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2003 Tim Janik";
}
static BseExportNodeProc __enode_list_parts_uniq = {
  { (BseExportNode*) &__enode_list_parts, BSE_EXPORT_NODE_PROC,
    "BseTrack+list-parts-uniq", 
    NULL,
    "/Methods/BseTrack/General/List Parts Uniq",
    NULL,
    __enode_list_parts_uniq__fill_strings,
  },
  0, list_parts_uniq_setup, list_parts_uniq_exec, 
};
extern "C" BseExportNode* bse__builtin_init_bsetrack_genprc_cc (void)
{
  return (BseExportNode*) &__enode_list_parts_uniq;
}

/*
 * Generated data ends here
 */
